searchNodes=[{"type":"module","title":"Earmark","doc":"Earmark Abstract Syntax Tree and Rendering The AST generation has now been moved out to EarmarkParser which is installed as a dependency. This brings some changes to this documentation and also deprecates the usage of Earmark.as_ast Earmark takes care of rendering the AST to HTML, exposing some AST Transformation Tools and providing a CLI as escript. Therefore you will not find a detailed description of the supported Markdown here anymore as this is done in here Earmark.as_ast WARNING: This is just a proxy towards EarmarkParser.as_ast and is deprecated, it will be removed in version 1.5! Replace your calls to Earmark.as_ast with EarmarkParse.as_ast as soon as possible. N.B. If all you use is Earmark.as_ast consider only using EarmarkParser . Also please refer yourself to the documentation of EarmarkParser The function is described below and the other two API functions as_html and as_html! are now based upon the structure of the result of as_ast . { :ok , ast , [ ] } = EarmarkParser . as_ast ( markdown ) { :ok , ast , deprecation_messages } = EarmarkParser . as_ast ( markdown ) { :error , ast , error_messages } = EarmarkParser . as_ast ( markdown ) Earmark.as_html { :ok , html_doc , [ ] } = Earmark . as_html ( markdown ) { :ok , html_doc , deprecation_messages } = Earmark . as_html ( markdown ) { :error , html_doc , error_messages } = Earmark . as_html ( markdown ) Earmark.as_html! html_doc = Earmark . as_html! ( markdown , options ) Formats the error_messages returned by as_html and adds the filename to each. Then prints them to stderr and just returns the html_doc Options Options can be passed into as as_html/2 or as_html!/2 according to the documentation. A keyword list with legal options (c.f. Earmark.Options ) or an Earmark.Options struct are accepted. { status , html_doc , errors } = Earmark . as_html ( markdown , options ) html_doc = Earmark . as_html! ( markdown , options ) { status , ast , errors } = EarmarkParser . as_ast ( markdown , options ) Rendering All options passed through to EarmarkParser.as_ast are defined therein, however some options concern only the rendering of the returned AST These are: compact_output: defaults to false Normally Earmark aims to produce Human Readable output. This will give results like these: iex(1)&gt; markdown = &quot;# Hello \\n World&quot; ...(1)&gt; Earmark . as_html! ( markdown , compact_output : false ) &quot;&lt;h1&gt; \\n Hello&lt;/h1&gt; \\n &lt;p&gt; \\n World&lt;/p&gt; \\n &quot; But sometimes whitespace is not desired: iex(2)&gt; markdown = &quot;# Hello \\n World&quot; ...(2)&gt; Earmark . as_html! ( markdown , compact_output : true ) &quot;&lt;h1&gt;Hello&lt;/h1&gt;&lt;p&gt;World&lt;/p&gt;&quot; Be cautions though when using this options, lines will become loooooong. escape: defaulting to true If set HTML will be properly escaped iex(3)&gt; markdown = &quot;Hello&lt;br&gt;World&quot; ...(3)&gt; Earmark . as_html! ( markdown ) &quot;&lt;p&gt; \\n Hello&amp;lt;br&amp;gt;World&lt;/p&gt; \\n &quot; However disabling escape: gives you maximum control of the created document, which in some cases (e.g. inside tables) might even be necessary iex(4)&gt; markdown = &quot;Hello&lt;br&gt;World&quot; ...(4)&gt; Earmark . as_html! ( markdown , escape : false ) &quot;&lt;p&gt; \\n Hello&lt;br&gt;World&lt;/p&gt; \\n &quot; inner_html: defaulting to false This is especially useful inside templates, when a block element will disturb the layout as in this case &lt;span&gt;&lt;%= Earmark.as_html!(....)%&gt;&lt;/span&gt; &lt;span&gt;&lt;%= Earmark.as_html!(....)%&gt;&lt;/span&gt; By means of the inner_html option the disturbing paragraph can be removed from as_html! 's output iex(5)&gt; markdown = &quot;Hello&lt;br&gt;World&quot; ...(5)&gt; Earmark . as_html! ( markdown , escape : false , inner_html : true ) &quot;Hello&lt;br&gt;World \\n &quot; N.B. that this applies only to top level paragraphs, as can be seen here iex(6)&gt; markdown = &quot;- Item \\n \\n Para&quot; ...(6)&gt; Earmark . as_html! ( markdown , inner_html : true ) &quot;&lt;ul&gt; \\n &lt;li&gt; \\n Item &lt;/li&gt; \\n &lt;/ul&gt; \\n Para \\n &quot; postprocessor: defaults to nil Before rendering, the AST is transformed by a postprocessor. For details, see the description of Earmark.Transform.map_ast below which will accept the same postprocessor. As a matter of fact, specifying postprocessor: fun is conceptually the same as markdown |&gt; EarmarkParser . as_ast |&gt; Earmark.Transform . map_ast ( fun ) |&gt; Earmark.Transform . transform with all the necessary bookkeeping for options and messages renderer: defaults to Earmark.HtmlRenderer The module used to render the final document. smartypants: defaulting to true If set the following replacements will be made during rendering of inline text &quot;---&quot; → &quot;—&quot; &quot;--&quot; → &quot;–&quot; &quot;&#39; → &quot; ’ &quot; ?&quot; → &quot;”&quot; &quot;...&quot; → &quot;…&quot; Command line $ mix escript.build $ ./earmark file.md Some options defined in the Earmark.Options struct can be specified as command line switches. Use $ ./earmark --help to find out more, but here is a short example $ ./earmark --smartypants false --code-class-prefix &quot;a- b-&quot; file.md will call Earmark.as_html!( ..., %Earmark.Options{smartypants: false, code_class_prefix: &quot;a- b-&quot;}) Timeouts By default, that is if the timeout option is not set Earmark uses parallel mapping as implemented in Earmark.pmap/2 , which uses Task.await with its default timeout of 5000ms. In rare cases that might not be enough. By indicating a longer timeout option in milliseconds Earmark will use parallel mapping as implemented in Earmark.pmap/3 , which will pass timeout to Task.await . In both cases one can override the mapper function with either the mapper option (used if and only if timeout is nil) or the mapper_with_timeout function (used otherwise). For the escript only the timeout command line argument can be used. Security Please be aware that Markdown is not a secure format. It produces HTML from Markdown and HTML. It is your job to sanitize and or filter the output of Earmark.as_html if you cannot trust the input and are to serve the produced HTML on the Web.","ref":"Earmark.html"},{"type":"function","title":"Earmark.as_ast/2","doc":"DEPRECATED call EarmarkParser.as_ast instead","ref":"Earmark.html#as_ast/2"},{"type":"function","title":"Earmark.as_ast!/2","doc":"See Earmark.Internal.as_ast!/2 .","ref":"Earmark.html#as_ast!/2"},{"type":"function","title":"Earmark.as_html/2","doc":"See Earmark.Internal.as_html/2 .","ref":"Earmark.html#as_html/2"},{"type":"function","title":"Earmark.as_html!/2","doc":"See Earmark.Internal.as_html!/2 .","ref":"Earmark.html#as_html!/2"},{"type":"function","title":"Earmark.from_file!/2","doc":"A convenience method that always returns an HTML representation of the markdown document passed in. In case of the presence of any error messages they are printed to stderr. Otherwise it behaves exactly as as_html .","ref":"Earmark.html#from_file!/2"},{"type":"function","title":"Earmark.pmap/3","doc":"See Earmark.Internal.pmap/3 .","ref":"Earmark.html#pmap/3"},{"type":"function","title":"Earmark.transform/2","doc":"See Earmark.Transform.transform/2 .","ref":"Earmark.html#transform/2"},{"type":"function","title":"Earmark.version/0","doc":"Accesses current hex version of the Earmark application. Convenience for iex usage.","ref":"Earmark.html#version/0"},{"type":"type","title":"Earmark.ast/0","doc":"","ref":"Earmark.html#t:ast/0"},{"type":"type","title":"Earmark.ast_attribute/0","doc":"","ref":"Earmark.html#t:ast_attribute/0"},{"type":"type","title":"Earmark.ast_attribute_name/0","doc":"","ref":"Earmark.html#t:ast_attribute_name/0"},{"type":"type","title":"Earmark.ast_attribute_value/0","doc":"","ref":"Earmark.html#t:ast_attribute_value/0"},{"type":"type","title":"Earmark.ast_attributes/0","doc":"","ref":"Earmark.html#t:ast_attributes/0"},{"type":"type","title":"Earmark.ast_meta/0","doc":"","ref":"Earmark.html#t:ast_meta/0"},{"type":"type","title":"Earmark.ast_node/0","doc":"","ref":"Earmark.html#t:ast_node/0"},{"type":"type","title":"Earmark.ast_tag/0","doc":"","ref":"Earmark.html#t:ast_tag/0"},{"type":"type","title":"Earmark.ast_tuple/0","doc":"","ref":"Earmark.html#t:ast_tuple/0"},{"type":"module","title":"Earmark.AstTools","doc":"Tools for AST manipulation","ref":"Earmark.AstTools.html"},{"type":"function","title":"Earmark.AstTools.find_att_in_node/2","doc":"Convenience function to access an attribute iex(4)&gt; find_att_in_node ( { &quot;a&quot; , [ { &quot;class&quot; , &quot;link&quot; } ] , [ ] , %{ } } , &quot;class&quot; ) &quot;link&quot; iex(5)&gt; find_att_in_node ( { &quot;a&quot; , [ { &quot;class&quot; , &quot;link&quot; } ] , [ ] , %{ } } , &quot;target&quot; ) nil iex(6)&gt; find_att_in_node ( { &quot;a&quot; , [ { &quot;class&quot; , &quot;link&quot; } ] , [ ] , %{ } } , &quot;target&quot; , :default ) :default iex(7)&gt; find_att_in_node ( [ { &quot;class&quot; , &quot;link&quot; } ] , &quot;class&quot; ) &quot;link&quot; iex(8)&gt; find_att_in_node ( [ { &quot;class&quot; , &quot;link&quot; } ] , &quot;target&quot; ) nil iex(9)&gt; find_att_in_node ( [ { &quot;class&quot; , &quot;link&quot; } ] , &quot;target&quot; , :default ) :default","ref":"Earmark.AstTools.html#find_att_in_node/2"},{"type":"function","title":"Earmark.AstTools.find_att_in_node/3","doc":"","ref":"Earmark.AstTools.html#find_att_in_node/3"},{"type":"function","title":"Earmark.AstTools.merge_atts/2","doc":"A helper to merge attributes in their cannonical representation iex(1)&gt; merge_atts ( [ { &quot;href&quot; , &quot;url&quot; } ] , target : &quot;_blank&quot; ) [ { &quot;href&quot; , &quot;url&quot; } , { &quot;target&quot; , &quot;_blank&quot; } ] iex(2)&gt; merge_atts ( [ { &quot;href&quot; , &quot;url&quot; } , { &quot;target&quot; , &quot;nonsense&quot; } ] , %{ &quot;target&quot; =&gt; &quot;_blank&quot; } ) [ { &quot;href&quot; , &quot;url&quot; } , { &quot;target&quot; , &quot;_blank nonsense&quot; } ] iex(3)&gt; merge_atts ( [ { &quot;href&quot; , &quot;url&quot; } , { &quot;target&quot; , &quot;nonsense&quot; } , { &quot;alt&quot; , &quot;nowhere&quot; } ] , ...(3)&gt; [ { &quot;target&quot; , &quot;_blank&quot; } , title : &quot;where?&quot; ] ) [ { &quot;alt&quot; , &quot;nowhere&quot; } , { &quot;href&quot; , &quot;url&quot; } , { &quot;target&quot; , &quot;_blank nonsense&quot; } , { &quot;title&quot; , &quot;where?&quot; } ]","ref":"Earmark.AstTools.html#merge_atts/2"},{"type":"function","title":"Earmark.AstTools.merge_atts_in_node/2","doc":"A convenience function that extracts the original attributes to be merged with new attributes and puts the result into the node again iex(10)&gt; merge_atts_in_node ( { &quot;img&quot; , [ { &quot;src&quot; , &quot;there&quot; } , { &quot;alt&quot; , &quot;there&quot; } ] , [ ] , %{ some : &quot;meta&quot; } } , alt : &quot;here&quot; ) { &quot;img&quot; , [ { &quot;alt&quot; , &quot;here there&quot; } , { &quot;src&quot; , &quot;there&quot; } ] , [ ] , %{ some : &quot;meta&quot; } }","ref":"Earmark.AstTools.html#merge_atts_in_node/2"},{"type":"function","title":"Earmark.AstTools.node_only_fn/1","doc":"Wrap a function that can only be called on nodes iex(11)&gt; f = fn { t , _ , _ , _ } -&gt; t end ...(11)&gt; f_ = node_only_fn ( f ) ...(11)&gt; { f_ . ( { &quot;p&quot; , [ ] , [ ] , %{ } } ) , f_ . ( &quot;text&quot; ) } { &quot;p&quot; , &quot;text&quot; }","ref":"Earmark.AstTools.html#node_only_fn/1"},{"type":"module","title":"Earmark.Cli","doc":"The Earmark CLI Entry point of the escript, this is the only point that does IO with output and it uses the Earmark.File module which is the only point that does IO with input.","ref":"Earmark.Cli.html"},{"type":"function","title":"Earmark.Cli.main/1","doc":"This is the entry point of the escript","ref":"Earmark.Cli.html#main/1"},{"type":"function","title":"Earmark.Cli.run!/1","doc":"A convenience wrapper around Earmark.Cli.Implementation.run/1 it will return str in case {:stdio, str} is returned or raise an error otherwise iex(0)&gt; run! ( [ &quot;test/fixtures/short1.md&quot; ] ) &quot;&lt;h1&gt; \\n Headline1&lt;/h1&gt; \\n &lt;hr class= \\&quot; thin \\&quot; &gt; \\n &lt;h2&gt; \\n Headline2&lt;/h2&gt; \\n &quot;","ref":"Earmark.Cli.html#run!/1"},{"type":"module","title":"Earmark.Cli.Implementation","doc":"Functional (with the exception of reading input files with Earmark.File ) interface to the CLI returning the device and the string to be output.","ref":"Earmark.Cli.Implementation.html"},{"type":"function","title":"Earmark.Cli.Implementation.run/1","doc":"allows functional access to the CLI API, does everything Earmark.Cli.main does without outputting the result Returns a tuple of the device to write to ( :stdio|:stderr ) and the content to be written Example: Bad file iex(0)&gt; run([&quot;no-such--file--ayK7k&quot;]) Example: Good file iex(1)&gt; {:stdio, html} = run([&quot;test/fixtures/short1.md&quot;]) ...(1)&gt; html &quot;&lt;h1&gt;\\nHeadline1&lt;/h1&gt;\\n&lt;hr class=\\&quot;thin\\&quot;&gt;\\n&lt;h2&gt;\\nHeadline2&lt;/h2&gt;\\n&quot; Example: Using EEx iex(2)&gt; {:stdio, html} = run([&quot;--eex&quot;, &quot;--gfm&quot;, &quot;--code-class-prefix&quot;, &quot;alpha&quot;, &quot;--timeout&quot;, &quot;12000&quot;, &quot;test/fixtures/short2.md.eex&quot;]) ...(2)&gt; html &quot;&lt;h1&gt;\\nShort2&lt;/h1&gt;\\n&lt;p&gt;\\n&lt;em&gt;Short3&lt;/em&gt;&lt;/p&gt;\\n&lt;!-- SPDX-License-Identifier: Apache-2.0 --&gt;\\n&quot; Example: Using an EEx template first iex(3)&gt; run([&quot;--template&quot;, &quot;test/fixtures/eex_first.html.eex&quot;])","ref":"Earmark.Cli.Implementation.html#run/1"},{"type":"module","title":"Earmark.EarmarkParserProxy","doc":"This acts as a proxy to adapt to changes in EarmarkParser 's API If no changes are needed it can delegate as_ast to EarmarkParser If changes are needed they will be realised in this modules as_ast function. For that reason EarmarkParser.as_ast/* SHALL NOT be invoked anywhere else in this code base","ref":"Earmark.EarmarkParserProxy.html"},{"type":"function","title":"Earmark.EarmarkParserProxy.as_ast/2","doc":"An adapter to EarmarkParser.as_ast/*","ref":"Earmark.EarmarkParserProxy.html#as_ast/2"},{"type":"module","title":"Earmark.Helpers","doc":"","ref":"Earmark.Helpers.html"},{"type":"function","title":"Earmark.Helpers.replace/4","doc":"Regex.replace with the arguments in the correct order","ref":"Earmark.Helpers.html#replace/4"},{"type":"module","title":"Earmark.Internal","doc":"All public functions that are internal to Earmark, so that only external API functions are public in Earmark","ref":"Earmark.Internal.html"},{"type":"function","title":"Earmark.Internal.as_ast!/2","doc":"A wrapper to extract the AST from a call to EarmarkParser.as_ast if a tuple {:ok, result, []} is returned, raise errors otherwise iex(1)&gt; as_ast! ( [ &quot;Hello %% annotated&quot; ] , annotations : &quot;%%&quot; ) [ { &quot;p&quot; , [ ] , [ &quot;Hello &quot; ] , %{ annotation : &quot;%% annotated&quot; } } ] iex(2)&gt; as_ast! ( &quot;===&quot; ) ** (Earmark.Error) [{:warning, 1, &quot;Unexpected line ===&quot;}]","ref":"Earmark.Internal.html#as_ast!/2"},{"type":"function","title":"Earmark.Internal.as_html!/2","doc":"","ref":"Earmark.Internal.html#as_html!/2"},{"type":"function","title":"Earmark.Internal.from_file!/2","doc":"This is a convenience method to read a file or pass it to EEx.eval_file if its name ends in .eex The returned string is then passed to as_html this is used in the escript now and allows for a simple inclusion mechanism, as a matter of fact an include function is passed","ref":"Earmark.Internal.html#from_file!/2"},{"type":"function","title":"Earmark.Internal.include/2","doc":"A utility function that will be passed as a partial capture to EEx.eval_file by providing a value for the options parameter EEx . eval ( ... , include : &amp; include ( &amp;1 , options ) ) thusly allowing &lt;%= include.(some file) %&gt; where some file can be a relative path starting with &quot;./&quot; Here is an example using these fixtures iex(3)&gt; include ( &quot;./include/basic.md.eex&quot; , file : &quot;test/fixtures/does_not_matter&quot; ) &quot;# Headline Level 1 \\n &quot; And here is how it is used inside a template iex(4)&gt; options = [ file : &quot;test/fixtures/does_not_matter&quot; ] ...(4)&gt; EEx . eval_string ( ~s{&lt;%= include.(&quot;./include/basic.md.eex&quot;) %&gt;} , include : &amp; include ( &amp;1 , options ) ) &quot;# Headline Level 1 \\n &quot;","ref":"Earmark.Internal.html#include/2"},{"type":"module","title":"Earmark.Options","doc":"This is a superset of the options that need to be passed into EarmarkParser.as_ast/2 The following options are proper to Earmark only and therefore explained in detail compact_output : boolean indicating to avoid indentation and minimize whitespace eex : Allows usage of an EEx template to be expanded to markdown before conversion file : Name of file passed in from the CLI line : 1 but might be set to an offset for better error messages in some integration cases smartypants : boolean use Smarty Pants in the output ignore_strings , postprocessor and registered_processors : processors that modify the AST returned from EarmarkParser.as_ast/ 2 before rendering ( post because preprocessing is done on the markdown, e.g. eex ) Refer to the moduledoc of Earmark. Transform for details All other options are passed onto EarmarkParser.as_ast/ 2","ref":"Earmark.Options.html"},{"type":"function","title":"Earmark.Options.make_options/1","doc":"Make a legal and normalized Option struct from, maps or keyword lists Without a param or an empty input we just get a new Option struct iex(1)&gt; { make_options(), make_options(%{}) } { {:ok, %Earmark.Options{}}, {:ok, %Earmark.Options{}} } The same holds for the bang version of course iex(2)&gt; { make_options!(), make_options!(%{}) } { %Earmark.Options{}, %Earmark.Options{} } We check for unallowed keys iex(3)&gt; make_options(no_such_option: true) {:error, [{:warning, 0, &quot;Unrecognized option no_such_option: true&quot;}]} Of course we do not let our users discover one error after another iex(4)&gt; make_options(no_such_option: true, gfm: false, still_not_an_option: 42) {:error, [{:warning, 0, &quot;Unrecognized option no_such_option: true&quot;}, {:warning, 0, &quot;Unrecognized option still_not_an_option: 42&quot;}]} And the bang version will raise an Earmark.Error as excepted (sic) iex(5)&gt; make_options!(no_such_option: true, gfm: false, still_not_an_option: 42) ** (Earmark.Error) [{:warning, 0, &quot;Unrecognized option no_such_option: true&quot;}, {:warning, 0, &quot;Unrecognized option still_not_an_option: 42&quot;}] Some values need to be numeric iex(6)&gt; make_options(line: &quot;42&quot;) {:error, [{:error, 0, &quot;line option must be numeric&quot;}]} iex(7)&gt; make_options(%Earmark.Options{footnote_offset: &quot;42&quot;}) {:error, [{:error, 0, &quot;footnote_offset option must be numeric&quot;}]} iex(8)&gt; make_options(%{line: &quot;42&quot;, footnote_offset: nil}) {:error, [{:error, 0, &quot;footnote_offset option must be numeric&quot;}, {:error, 0, &quot;line option must be numeric&quot;}]}","ref":"Earmark.Options.html#make_options/1"},{"type":"function","title":"Earmark.Options.make_options!/1","doc":"","ref":"Earmark.Options.html#make_options!/1"},{"type":"function","title":"Earmark.Options.relative_filename/2","doc":"Allows to compute the path of a relative file name (starting with &quot;./&quot; ) from the file in options and return an updated options struct iex(9)&gt; options = %Earmark.Options{file: &quot;some/path/xxx.md&quot;} ...(9)&gt; options = relative_filename(options, &quot;./local.md&quot;) ...(9)&gt; options .file &quot;some/path/local.md&quot; For your convenience you can just use a keyword list iex(10)&gt; options = relative filename([file: &quot;some/path/ .md&quot;, breaks: true], &quot;./local.md&quot;) ...(10)&gt; {options.file, options.breaks} {&quot;some/path/local.md&quot;, true} If the filename is not absolute it just replaces the file in options iex(11)&gt; options = %Earmark.Options{file: &quot;some/path/xxx.md&quot;} ...(11)&gt; options = relative_filename(options, &quot;local.md&quot;) ...(11)&gt; options .file &quot;local.md&quot; And there is a special case when processing stdin, meaning that file: nil we replace file verbatim in that case iex(12)&gt; options = %Earmark.Options{} ...(12)&gt; options = relative_filename(options, &quot;./local.md&quot;) ...(12)&gt; options .file &quot;./local.md&quot;","ref":"Earmark.Options.html#relative_filename/2"},{"type":"function","title":"Earmark.Options.with_postprocessor/2","doc":"A convenience constructor","ref":"Earmark.Options.html#with_postprocessor/2"},{"type":"module","title":"Earmark.Restructure","doc":"","ref":"Earmark.Restructure.html"},{"type":"function","title":"Earmark.Restructure.merge_lists/3","doc":"Given two lists that are either of equal length, or with the first list exactly one element longer than the second, returns a list that begins with the first element from the first list, then the first element from the second list, and so forth until both lists are empty.","ref":"Earmark.Restructure.html#merge_lists/3"},{"type":"function","title":"Earmark.Restructure.split_by_regex/3","doc":"Utility for creating a restructuring that parses text by splitting it into parts &quot;of interest&quot; vs. &quot;other parts&quot; using a regular expression. Returns a list of parts where the parts matching regex have been processed by invoking map_captures_fn on each part, and a list of remaining parts, preserving the order of parts from what it was in the plain text item. iex(2)&gt; input = &quot;This is ::all caps::, right?&quot; ...(2)&gt; split_by_regex ( input , ~r/::(.*?)::/ , fn [ _ , inner | _ ] -&gt; String . upcase ( inner ) end ) [ &quot;This is &quot; , &quot;ALL CAPS&quot; , &quot;, right?&quot; ]","ref":"Earmark.Restructure.html#split_by_regex/3"},{"type":"function","title":"Earmark.Restructure.walk_and_modify_ast/4","doc":"Walks an AST and allows you to process it (storing details in acc) and/or modify it as it is walked. items is the AST you got from EarmarkParser.as_ast() acc is the initial value of an accumulator that is passed to both process_item_fn and process_list_fn and accumulated. If your functions do not need to use or store any state, you can pass nil. The process_item_fn function is required. It takes two parameters, the single item to process (which will either be a string or a 4-tuple) and the accumulator, and returns a tuple {processed_item, updated_acc}. Returning the empty list for processed_item will remove the item processed the AST. The process_list_fn function is optional and defaults to no modification of items or accumulator. It takes two parameters, the list of items that are the sub-items of a given element in the AST (or the top-level list of items), and the accumulator, and returns a tuple {processed_items_list, updated_acc}. This function ends up returning {ast, acc}. Here is an example using a custom format to make &lt;em&gt; nodes and allowing commented text to be left out iex(1)&gt; is_comment? = fn item -&gt; is_binary ( item ) &amp;&amp; Regex . match? ( ~r/ \\A \\s *--/ , item ) end ...(1)&gt; comment_remover = ...(1)&gt; fn items , acc -&gt; { Enum . reject ( items , is_comment? ) , acc } end ...(1)&gt; italics_maker = fn ...(1)&gt; item , acc when is_binary ( item ) -&gt; ...(1)&gt; new_item = Restructure . split_by_regex ( ...(1)&gt; item , ...(1)&gt; ~r/ \\/ ([[:graph:]].*?[[:graph:]]|[[:graph:]]) \\/ / , ...(1)&gt; fn [ _ , content ] -&gt; ...(1)&gt; { &quot;em&quot; , [ ] , [ content ] , %{ } } ...(1)&gt; end ...(1)&gt; ) ...(1)&gt; { new_item , acc } ...(1)&gt; item , &quot;a&quot; -&gt; { item , nil } ...(1)&gt; { name , _ , _ , _ } = item , _ -&gt; { item , name } ...(1)&gt; end ...(1)&gt; markdown = &quot;&quot;&quot; ...(1)&gt; [no italics in links](http://example.io/some/path) ...(1)&gt; but /here/ ...(1)&gt; ...(1)&gt; -- ignore me ...(1)&gt; ...(1)&gt; text ...(1)&gt; &quot;&quot;&quot; ...(1)&gt; { :ok , ast , [ ] } = EarmarkParser . as_ast ( markdown ) ...(1)&gt; Restructure . walk_and_modify_ast ( ast , nil , italics_maker , comment_remover ) { [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;http://example.io/some/path&quot; } ] , [ &quot;no italics in links&quot; ] , %{ } } , &quot; \\n but &quot; , { &quot;em&quot; , [ ] , [ &quot;here&quot; ] , %{ } } , &quot;&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;text&quot; ] , %{ } } ] , &quot;p&quot; }","ref":"Earmark.Restructure.html#walk_and_modify_ast/4"},{"type":"module","title":"Earmark.SysInterface","doc":"","ref":"Earmark.SysInterface.html"},{"type":"function","title":"Earmark.SysInterface.readlines/1","doc":"A proxy to IO.stream(..., :line) or usage with a filename","ref":"Earmark.SysInterface.html#readlines/1"},{"type":"module","title":"Earmark.TagSpecificProcessors","doc":"This struct represents a list of tuples {tag, function} from which a postprocessing function can be constructed General Usage Examples: iex(0)&gt; tsp = new ( { &quot;p&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;one&quot; ) } ) ...(0)&gt; tsp = prepend_tag_function ( tsp , &quot;i&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;two&quot; ) ) ...(0)&gt; make_postprocessor ( tsp ) . ( { &quot;p&quot; , [ ] , nil , nil } ) { &quot;p&quot; , [ { &quot;class&quot; , &quot;one&quot; } ] , nil , nil } iex(1)&gt; tsp = new ( { &quot;p&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;one&quot; ) } ) ...(1)&gt; tsp = prepend_tag_function ( tsp , &quot;i&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;two&quot; ) ) ...(1)&gt; make_postprocessor ( tsp ) . ( { &quot;i&quot; , [ { &quot;class&quot; , &quot;i&quot; } ] , nil , nil } ) { &quot;i&quot; , [ { &quot;class&quot; , &quot;two i&quot; } ] , nil , nil } iex(2)&gt; tsp = new ( { &quot;p&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;one&quot; ) } ) ...(2)&gt; tsp = prepend_tag_function ( tsp , &quot;i&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;two&quot; ) ) ...(2)&gt; make_postprocessor ( tsp ) . ( { &quot;x&quot; , [ ] , nil , nil } ) { &quot;x&quot; , [ ] , nil , nil }","ref":"Earmark.TagSpecificProcessors.html"},{"type":"function","title":"Earmark.TagSpecificProcessors.make_postprocessor/1","doc":"Constructs a postprocessor function from this struct which will find the function associated to the tag of the node, and apply the node to it if such a function was found.","ref":"Earmark.TagSpecificProcessors.html#make_postprocessor/1"},{"type":"function","title":"Earmark.TagSpecificProcessors.new/0","doc":"Convenience construction iex(3)&gt; new ( ) % Earmark.TagSpecificProcessors { }","ref":"Earmark.TagSpecificProcessors.html#new/0"},{"type":"function","title":"Earmark.TagSpecificProcessors.new/1","doc":"","ref":"Earmark.TagSpecificProcessors.html#new/1"},{"type":"function","title":"Earmark.TagSpecificProcessors.prepend_tag_function/2","doc":"","ref":"Earmark.TagSpecificProcessors.html#prepend_tag_function/2"},{"type":"function","title":"Earmark.TagSpecificProcessors.prepend_tag_function/3","doc":"Prepends a tuple {tag, function} to the list of such tuples.","ref":"Earmark.TagSpecificProcessors.html#prepend_tag_function/3"},{"type":"module","title":"Earmark.Transform","doc":"Structure Conserving Transformers For the convenience of processing the output of EarmarkParser.as_ast we expose two structure conserving mappers. map_ast Traverses an AST using a mapper function. The mapper function will be called for each node including text elements unless map_ast is called with the third positional parameter ignore_strings , which is optional and defaults to false , set to true . Depending on the return value of the mapper function the traversal will either {new_tag, new_atts, ignored, new_meta} just replace the tag , attribute and meta values of the current node with the values of the returned quadruple (ignoring ignored for facilitating nodes w/o transformation) and then descend into the original content of the node. {:replace, node} replaces the current node with node and does not descend anymore, but continues traversal on sibblings. {new_function, {new_tag, new_atts, ignored, new_meta}} just replace the tag , attribute and meta values of the current node with the values of the returned quadruple (ignoring ignored for facilitating nodes w/o transformation) and then descend into the original content of the node but with the mapper function new_function used for transformation of the AST. N.B. The original mapper function will be used for transforming the sibbling nodes though. takes a function that will be called for each node of the AST, where a leaf node is either a quadruple like {&quot;code&quot;, [{&quot;class&quot;, &quot;inline&quot;}], [&quot;some code&quot;], %{}} or a text leaf like &quot;some code&quot; The result of the function call must be for nodes → as described above for strings → strings or nodes As an example let us transform an ast to have symbol keys iex(1)&gt; input = [ ...(1)&gt; { &quot;h1&quot; , [ ] , [ &quot;Hello&quot; ] , %{ title : true } } , ...(1)&gt; { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;alpha&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;beta&quot; ] , %{ } } ] , %{ } } ] ...(1)&gt; map_ast ( input , fn { t , a , _ , m } -&gt; { String . to_atom ( t ) , a , nil , m } end , true ) [ { :h1 , [ ] , [ &quot;Hello&quot; ] , %{ title : true } } , { :ul , [ ] , [ { :li , [ ] , [ &quot;alpha&quot; ] , %{ } } , { :li , [ ] , [ &quot;beta&quot; ] , %{ } } ] , %{ } } ] N.B. If this returning convention is not respected map_ast might not complain, but the resulting transformation might not be suitable for Earmark.Transform.transform anymore. From this follows that any function passed in as value of the postprocessor: option must obey to these conventions. map_ast_with this is like map_ast but like a reducer an accumulator can also be passed through. For that reason the function is called with two arguments, the first element being the same value as in map_ast and the second the accumulator. The return values need to be equally augmented tuples. A simple example, annotating traversal order in the meta map's :count key, as we are not interested in text nodes we use the fourth parameter ignore_strings which defaults to false iex(2)&gt; input = [ ...(2)&gt; { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;one&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;two&quot; ] , %{ } } ] , %{ } } , ...(2)&gt; { &quot;p&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ] ...(2)&gt; counter = fn { t , a , _ , m } , c -&gt; { { t , a , nil , Map . put ( m , :count , c ) } , c + 1 } end ...(2)&gt; map_ast_with ( input , 0 , counter , true ) { [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;one&quot; ] , %{ count : 1 } } , { &quot;li&quot; , [ ] , [ &quot;two&quot; ] , %{ count : 2 } } ] , %{ count : 0 } } , { &quot;p&quot; , [ ] , [ &quot;hello&quot; ] , %{ count : 3 } } ] , 4 } Let us describe an implementation of a real world use case taken from Elixir Forum Simplifying the exact parsing of the text node in this example we only want to replace a text node of the form #elixir with a link to the Elixir home page but only when inside a {&quot;p&quot;,....} node We can achieve this as follows iex(3)&gt; elixir_home = { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://elixir-lang.org&quot; } ] , [ &quot;Elixir&quot; ] , %{ } } ...(3)&gt; transformer = fn { &quot;p&quot; , atts , _ , meta } , _ -&gt; { { &quot;p&quot; , atts , nil , meta } , true } ...(3)&gt; &quot;#elixir&quot; , true -&gt; { elixir_home , false } ...(3)&gt; text , _ when is_binary ( text ) -&gt; { text , false } ...(3)&gt; node , _ -&gt; { node , false } end ...(3)&gt; ast = [ ...(3)&gt; { &quot;p&quot; , [ ] , [ &quot;#elixir&quot; ] , %{ } } , { &quot;bold&quot; , [ ] , [ &quot;#elixir&quot; ] , %{ } } , ...(3)&gt; { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;#elixir&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;elixir&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;#elixir&quot; ] , %{ } } ] , %{ } } ...(3)&gt; ] ...(3)&gt; map_ast_with ( ast , false , transformer ) { [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://elixir-lang.org&quot; } ] , [ &quot;Elixir&quot; ] , %{ } } ] , %{ } } , { &quot;bold&quot; , [ ] , [ &quot;#elixir&quot; ] , %{ } } , { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;#elixir&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;elixir&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://elixir-lang.org&quot; } ] , [ &quot;Elixir&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , false } An alternate, maybe more elegant solution would be to change the mapper function during AST traversal as demonstrated here Postprocessors and Convenience Functions These can be declared in the fields postprocessor and registered_processors in the Options struct, postprocessor is prepened to registered_processors and they are all applied to non string nodes (that is the quadtuples of the AST which are of the form {tag, atts, content, meta} All postprocessors can just be functions on nodes or a TagSpecificProcessors struct which will group function applications depending on tags, as a convienience tuples of the form {tag, function} will be transformed into a TagSpecificProcessors struct. iex(4)&gt; add_class1 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class1&quot; ) ...(4)&gt; m1 = Earmark.Options . make_options! ( postprocessor : add_class1 ) |&gt; make_postprocessor ( ) ...(4)&gt; m1 . ( { &quot;a&quot; , [ ] , nil , nil } ) { &quot;a&quot; , [ { &quot;class&quot; , &quot;class1&quot; } ] , nil , nil } We can also use the registered_processors field: iex(5)&gt; add_class1 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class1&quot; ) ...(5)&gt; m2 = Earmark.Options . make_options! ( registered_processors : add_class1 ) |&gt; make_postprocessor ( ) ...(5)&gt; m2 . ( { &quot;a&quot; , [ ] , nil , nil } ) { &quot;a&quot; , [ { &quot;class&quot; , &quot;class1&quot; } ] , nil , nil } Knowing that values on the same attributes are added onto the front the following doctest demonstrates the order in which the processors are executed iex(6)&gt; add_class1 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class1&quot; ) ...(6)&gt; add_class2 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class2&quot; ) ...(6)&gt; add_class3 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class3&quot; ) ...(6)&gt; m = Earmark.Options . make_options! ( postprocessor : add_class1 , registered_processors : [ add_class2 , { &quot;a&quot; , add_class3 } ] ) ...(6)&gt; |&gt; make_postprocessor ( ) ...(6)&gt; [ { &quot;a&quot; , [ { &quot;class&quot; , &quot;link&quot; } ] , nil , nil } , { &quot;b&quot; , [ ] , nil , nil } ] ...(6)&gt; |&gt; Enum . map ( m ) [ { &quot;a&quot; , [ { &quot;class&quot; , &quot;class3 class2 class1 link&quot; } ] , nil , nil } , { &quot;b&quot; , [ { &quot;class&quot; , &quot;class2 class1&quot; } ] , nil , nil } ] We can see that the tuple form has been transformed into a tag specific transformation only as a matter of fact, the explicit definition would be: iex(7)&gt; m = make_postprocessor ( ...(7)&gt; % Earmark.Options { ...(7)&gt; registered_processors : ...(7)&gt; [ Earmark.TagSpecificProcessors . new ( { &quot;a&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , target : &quot;_blank&quot; ) } ) ] } ) ...(7)&gt; [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;url&quot; } ] , nil , nil } , { &quot;b&quot; , [ ] , nil , nil } ] ...(7)&gt; |&gt; Enum . map ( m ) [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;url&quot; } , { &quot;target&quot; , &quot;_blank&quot; } ] , nil , nil } , { &quot;b&quot; , [ ] , nil , nil } ] We can also define a tag specific transformer in one step, which might (or might not) solve potential performance issues when running too many processors iex(8)&gt; add_class4 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class4&quot; ) ...(8)&gt; add_class5 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class5&quot; ) ...(8)&gt; add_class6 = &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;class6&quot; ) ...(8)&gt; tsp = Earmark.TagSpecificProcessors . new ( [ { &quot;a&quot; , add_class5 } , { &quot;b&quot; , add_class5 } ] ) ...(8)&gt; m = Earmark.Options . make_options! ( ...(8)&gt; postprocessor : add_class4 , ...(8)&gt; registered_processors : [ tsp , add_class6 ] ) ...(8)&gt; |&gt; make_postprocessor ( ) ...(8)&gt; [ { &quot;a&quot; , [ ] , nil , nil } , { &quot;c&quot; , [ ] , nil , nil } , { &quot;b&quot; , [ ] , nil , nil } ] ...(8)&gt; |&gt; Enum . map ( m ) [ { &quot;a&quot; , [ { &quot;class&quot; , &quot;class6 class5 class4&quot; } ] , nil , nil } , { &quot;c&quot; , [ { &quot;class&quot; , &quot;class6 class4&quot; } ] , nil , nil } , { &quot;b&quot; , [ { &quot;class&quot; , &quot;class6 class5 class4&quot; } ] , nil , nil } ] Of course the mechanics shown above is hidden if all we want is to trigger the postprocessor chain in Earmark.as_html , here goes a typical example iex(9)&gt; add_target = fn node -&gt; # This will only be applied to nodes as it will become a TagSpecificProcessors ...(9)&gt; if Regex . match? ( ~r{ \\. x \\. com \\z } , Earmark.AstTools . find_att_in_node ( node , &quot;href&quot; , &quot;&quot; ) ) , do : ...(9)&gt; Earmark.AstTools . merge_atts_in_node ( node , target : &quot;_blank&quot; ) , else : node end ...(9)&gt; options = [ ...(9)&gt; registered_processors : [ { &quot;a&quot; , add_target } , { &quot;p&quot; , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;example&quot; ) } ] ] ...(9)&gt; markdown = [ ...(9)&gt; &quot;http://hello.x.com&quot; , ...(9)&gt; &quot;&quot; , ...(9)&gt; &quot;[some](url)&quot; , ...(9)&gt; ] ...(9)&gt; Earmark . as_html! ( markdown , options ) &quot;&lt;p class= \\&quot; example \\&quot; &gt; \\n &lt;a href= \\&quot; http://hello.x.com \\&quot; target= \\&quot; _blank \\&quot; &gt;http://hello.x.com&lt;/a&gt;&lt;/p&gt; \\n &lt;p class= \\&quot; example \\&quot; &gt; \\n &lt;a href= \\&quot; url \\&quot; &gt;some&lt;/a&gt;&lt;/p&gt; \\n &quot; Use case: Modification of Link Attributes depending on the URL This would be done as follows Earmark . as_html! ( markdown , registered_processors : { &quot;a&quot; , my_function_that_is_invoked_only_with_a_nodes } ) Use case: Modification of the AST according to Annotations N.B. Annotation are an experimental feature in 1.4.16-pre and are documented here By annotating our markdown source we can then influence the rendering. In this example we will just add some decoration iex(10)&gt; markdown = [ &quot;A joke %% smile&quot; , &quot;&quot; , &quot;Charming %% in_love&quot; ] ...(10)&gt; add_smiley = fn { _ , _ , _ , meta } = quad , _acc -&gt; ...(10)&gt; case Map . get ( meta , :annotation ) do ...(10)&gt; &quot;%% smile&quot; -&gt; { quad , &quot; \\u1F60 1&quot; } ...(10)&gt; &quot;%% in_love&quot; -&gt; { quad , &quot; \\u1F60 d&quot; } ...(10)&gt; _ -&gt; { quad , nil } ...(10)&gt; end ...(10)&gt; text , nil -&gt; { text , nil } ...(10)&gt; text , ann -&gt; { &quot; \#{ text } \#{ ann } &quot; , nil } ...(10)&gt; end ...(10)&gt; Earmark . as_ast! ( markdown , annotations : &quot;%%&quot; ) |&gt; Earmark.Transform . map_ast_with ( nil , add_smiley ) |&gt; Earmark . transform &quot;&lt;p&gt; \\n A joke ὠ1&lt;/p&gt; \\n &lt;p&gt; \\n Charming ὠd&lt;/p&gt; \\n &quot; Structure Modifying Transformers For structure modifications a tree traversal is needed and no clear pattern of how to assist this task with tools has emerged yet.","ref":"Earmark.Transform.html"},{"type":"function","title":"Earmark.Transform.make_postprocessor/1","doc":"","ref":"Earmark.Transform.html#make_postprocessor/1"},{"type":"function","title":"Earmark.Transform.map_ast/3","doc":"This is a structure conserving transformation iex(11)&gt; { :ok , ast , _ } = EarmarkParser . as_ast ( &quot;- one \\n - two \\n &quot; ) ...(11)&gt; map_ast ( ast , &amp; ( &amp;1 ) ) [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;one&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;two&quot; ] , %{ } } ] , %{ } } ] A more useful transformation iex(12)&gt; { :ok , ast , _ } = EarmarkParser . as_ast ( &quot;- one \\n - two \\n &quot; ) ...(12)&gt; fun = fn { _ , _ , _ , _ } = n -&gt; Earmark.AstTools . merge_atts_in_node ( n , class : &quot;private&quot; ) ...(12)&gt; string -&gt; string end ...(12)&gt; map_ast ( ast , fun ) [ { &quot;ul&quot; , [ { &quot;class&quot; , &quot;private&quot; } ] , [ { &quot;li&quot; , [ { &quot;class&quot; , &quot;private&quot; } ] , [ &quot;one&quot; ] , %{ } } , { &quot;li&quot; , [ { &quot;class&quot; , &quot;private&quot; } ] , [ &quot;two&quot; ] , %{ } } ] , %{ } } ] However the usage of the ignore_strings option renders the code much simpler iex(13)&gt; { :ok , ast , _ } = EarmarkParser . as_ast ( &quot;- one \\n - two \\n &quot; ) ...(13)&gt; map_ast ( ast , &amp; Earmark.AstTools . merge_atts_in_node ( &amp;1 , class : &quot;private&quot; ) , true ) [ { &quot;ul&quot; , [ { &quot;class&quot; , &quot;private&quot; } ] , [ { &quot;li&quot; , [ { &quot;class&quot; , &quot;private&quot; } ] , [ &quot;one&quot; ] , %{ } } , { &quot;li&quot; , [ { &quot;class&quot; , &quot;private&quot; } ] , [ &quot;two&quot; ] , %{ } } ] , %{ } } ]","ref":"Earmark.Transform.html#map_ast/3"},{"type":"function","title":"Earmark.Transform.map_ast_with/4","doc":"This too is a structure perserving transformation but a value is passed to the mapping function as an accumulator, and the mapping function needs to return the new node and the accumulator as a tuple, here is a simple example iex(14)&gt; { :ok , ast , _ } = EarmarkParser . as_ast ( &quot;- 1 \\n \\n 2 \\n - 3 \\n &quot; ) ...(14)&gt; summer = fn { &quot;li&quot; , _ , [ v ] , _ } = n , s -&gt; { v_ , _ } = Integer . parse ( v ) ; { n , s + v_ } ...(14)&gt; n , s -&gt; { n , s } end ...(14)&gt; map_ast_with ( ast , 0 , summer , true ) { [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;1&quot; ] , %{ } } ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;2&quot; ] , %{ } } , { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;3&quot; ] , %{ } } ] , %{ } } ] , 4 } or summing all numbers iex(15)&gt; { :ok , ast , _ } = EarmarkParser . as_ast ( &quot;- 1 \\n \\n 2 \\n - 3 \\n &quot; ) ...(15)&gt; summer = fn { _ , _ , _ , _ } = n , s -&gt; { n , s } ...(15)&gt; n , s -&gt; { n_ , _ } = Integer . parse ( n ) ; { &quot;*&quot; , s + n_ } end ...(15)&gt; map_ast_with ( ast , 0 , summer ) { [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;*&quot; ] , %{ } } ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;*&quot; ] , %{ } } , { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;*&quot; ] , %{ } } ] , %{ } } ] , 6 }","ref":"Earmark.Transform.html#map_ast_with/4"},{"type":"function","title":"Earmark.Transform.transform/2","doc":"Transforms an AST to html, also accepts the result of map_ast_with for convenience","ref":"Earmark.Transform.html#transform/2"},{"type":"module","title":"Earmark.Transform.Pop","doc":"A wrapper struct that wraps a mapping function and is pushed onto the stack for traversal. This not only allows to pop from the stack onto the result but to store an older mapper function for usage of a replacement mapper function for the subtree traversal","ref":"Earmark.Transform.Pop.html"},{"type":"module","title":"EarmarkParser","doc":"API EarmarkParser.as_ast This is the structure of the result of as_ast . { :ok , ast , [ ] } = EarmarkParser . as_ast ( markdown ) { :ok , ast , deprecation_messages } = EarmarkParser . as_ast ( markdown ) { :error , ast , error_messages } = EarmarkParser . as_ast ( markdown ) For examples see the functiondoc below. Options Options can be passed into as_ast/2 according to the documentation of EarmarkParser.Options . { status , ast , errors } = EarmarkParser . as_ast ( markdown , options ) Supports Standard Gruber markdown . Extensions Links Links supported by default Oneline HTML Link tags iex(1)&gt; EarmarkParser . as_ast ( ~s{&lt;a href=&quot;href&quot;&gt;link&lt;/a&gt;} ) { :ok , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;href&quot; } ] , [ &quot;link&quot; ] , %{ verbatim : true } } ] , [ ] } Markdown links New style ... iex(2)&gt; EarmarkParser . as_ast ( ~s{[title](destination)} ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;destination&quot; } ] , [ &quot;title&quot; ] , %{ } } ] , %{ } } ] , [ ] } and old style iex(3)&gt; EarmarkParser . as_ast ( &quot;[foo]: /url \\&quot; title \\&quot; \\n \\n [foo] \\n &quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;/url&quot; } , { &quot;title&quot; , &quot;title&quot; } ] , [ &quot;foo&quot; ] , %{ } } ] , %{ } } ] , [ ] } Autolinks iex(4)&gt; EarmarkParser . as_ast ( &quot;&lt;https://elixir-lang.com&gt;&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://elixir-lang.com&quot; } ] , [ &quot;https://elixir-lang.com&quot; ] , %{ } } ] , %{ } } ] , [ ] } Additional link parsing via options Pure links N.B. that the pure_links option is true by default iex(5)&gt; EarmarkParser . as_ast ( &quot;https://github.com&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://github.com&quot; } ] , [ &quot;https://github.com&quot; ] , %{ } } ] , %{ } } ] , [ ] } But can be deactivated iex(6)&gt; EarmarkParser . as_ast ( &quot;https://github.com&quot; , pure_links : false ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;https://github.com&quot; ] , %{ } } ] , [ ] } #### Wikilinks... are disabled by default iex(7)&gt; EarmarkParser . as_ast ( &quot;[[page]]&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;[[page]]&quot; ] , %{ } } ] , [ ] } and can be enabled iex(8)&gt; EarmarkParser . as_ast ( &quot;[[page]]&quot; , wikilinks : true ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;page&quot; } ] , [ &quot;page&quot; ] , %{ wikilink : true } } ] , %{ } } ] , [ ] } Sub and Sup HTML Elements This feature is not enabled by default but can be enabled with the option sub_sup: true Therefore we will get iex(9)&gt; EarmarkParser . as_ast ( &quot;H~2~O or a^n^ + b^n^ = c^n^&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;H~2~O or a^n^ + b^n^ = c^n^&quot; ] , %{ } } ] , [ ] } But by specifying sub_sup: true iex(10)&gt; EarmarkParser . as_ast ( &quot;H~2~O or a^n^ + b^n^ = c^n^&quot; , sub_sup : true ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;H&quot; , { &quot;sub&quot; , [ ] , [ &quot;2&quot; ] , %{ } } , &quot;O or a&quot; , { &quot;sup&quot; , [ ] , [ &quot;n&quot; ] , %{ } } , &quot; + b&quot; , { &quot;sup&quot; , [ ] , [ &quot;n&quot; ] , %{ } } , &quot; = c&quot; , { &quot;sup&quot; , [ ] , [ &quot;n&quot; ] , %{ } } ] , %{ } } ] , [ ] } Github Flavored Markdown GFM is supported by default, however as GFM is a moving target and all GFM extension do not make sense in a general context, EarmarkParser does not support all of it, here is a list of what is supported: Strike Through iex(11)&gt; EarmarkParser . as_ast ( &quot;~~hello~~&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;del&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ] , %{ } } ] , [ ] } GFM Tables Are not enabled by default iex(12)&gt; as_ast ( &quot;a|b \\\\ n-|- \\\\ nc|d \\\\ n&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;a|b \\\\ n-|- \\\\ nc|d \\\\ n&quot; ] , %{ } } ] , [ ] } But can be enabled with gfm_tables: true iex(13)&gt; as_ast ( &quot;a|b \\n -|- \\n c|d \\n &quot; , gfm_tables : true ) { :ok , [ { &quot;table&quot; , [ ] , [ { &quot;thead&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;th&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;a&quot; ] , %{ } } , { &quot;th&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;b&quot; ] , %{ } } ] , %{ } } ] , %{ } } , { &quot;tbody&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;c&quot; ] , %{ } } , { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;d&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , %{ } } ] , [ ] } Syntax Highlighting All backquoted or fenced code blocks with a language string are rendered with the given language as a class attribute of the code tag. For example: iex(14)&gt; [ ...(14)&gt; &quot;```elixir&quot; , ...(14)&gt; &quot; @tag :hello&quot; , ...(14)&gt; &quot;```&quot; ...(14)&gt; ] |&gt; as_ast ( ) { :ok , [ { &quot;pre&quot; , [ ] , [ { &quot;code&quot; , [ { &quot;class&quot; , &quot;elixir&quot; } ] , [ &quot; @tag :hello&quot; ] , %{ } } ] , %{ } } ] , [ ] } will be rendered as shown in the doctest above. If you want to integrate with a syntax highlighter with different conventions you can add more classes by specifying prefixes that will be put before the language string. Prism.js for example needs a class language-elixir . In order to achieve that goal you can add language- as a code_class_prefix to EarmarkParser.Options . In the following example we want more than one additional class, so we add more prefixes. iex(15)&gt; [ ...(15)&gt; &quot;```elixir&quot; , ...(15)&gt; &quot; @tag :hello&quot; , ...(15)&gt; &quot;```&quot; ...(15)&gt; ] |&gt; as_ast ( % EarmarkParser.Options { code_class_prefix : &quot;lang- language-&quot; } ) { :ok , [ { &quot;pre&quot; , [ ] , [ { &quot;code&quot; , [ { &quot;class&quot; , &quot;elixir lang-elixir language-elixir&quot; } ] , [ &quot; @tag :hello&quot; ] , %{ } } ] , %{ } } ] , [ ] } Footnotes N.B. Footnotes are disabled by default, use as_ast(..., footnotes: true) to enable them Footnotes are now a superset of GFM Footnotes. This implies some changes Footnote definitions ( [^footnote_id] ) must come at the end of your document ( GFM ) Footnotes that are not referenced are not rendered anymore ( GFM ) Footnote definitions can contain any markup with the exception of footnote definitions # iex(16)&gt; markdown = [ # ...(16)&gt; &quot;My reference[^to_footnote]&quot;, # ...(16)&gt; &quot;&quot;, # ...(16)&gt; &quot;[^1]: I am not rendered&quot;, # ...(16)&gt; &quot;[^to_footnote]: Important information&quot;] # ...(16)&gt; {:ok, ast, []} = as_ast(markdown, footnotes: true) # ...(16)&gt; ast # [ # {&quot;p&quot;, [], [&quot;My reference&quot;, # {&quot;a&quot;, # [{&quot;href&quot;, &quot;#fn:to_footnote&quot;}, {&quot;id&quot;, &quot;fnref:to_footnote&quot;}, {&quot;class&quot;, &quot;footnote&quot;}, {&quot;title&quot;, &quot;see footnote&quot;}], # [&quot;to_footnote&quot;], %{}} # ], %{}}, # {&quot;div&quot;, # [{&quot;class&quot;, &quot;footnotes&quot;}], # [{&quot;hr&quot;, [], [], %{}}, # {&quot;ol&quot;, [], # [{&quot;li&quot;, [{&quot;id&quot;, &quot;fn:to_footnote&quot;}], # [{&quot;a&quot;, [{&quot;title&quot;, &quot;return to article&quot;}, {&quot;class&quot;, &quot;reversefootnote&quot;}, {&quot;href&quot;, &quot;#fnref:to_footnote&quot;}], [&quot;&amp;#x21A9;&quot;], %{}}, # {&quot;p&quot;, [], [&quot;Important information&quot;], %{}}], %{}} # ], %{}}], %{}} # ] For more complex examples of footnotes, please refer to these tests Breaks Hard linebreaks are disabled by default iex(17)&gt; [ &quot;* a&quot; , &quot; b&quot; , &quot;c&quot; ] ...(17)&gt; |&gt; as_ast ( ) { :ok , [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;a \\n b \\n c&quot; ] , %{ } } ] , %{ } } ] , [ ] } But can be enabled with ` breaks : true ` iex(18)&gt; [ &quot;* a&quot; , &quot; b&quot; , &quot;c&quot; ] ...(18)&gt; |&gt; as_ast ( breaks : true ) { :ok , [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;a&quot; , { &quot;br&quot; , [ ] , [ ] , %{ } } , &quot;b&quot; , { &quot;br&quot; , [ ] , [ ] , %{ } } , &quot;c&quot; ] , %{ } } ] , %{ } } ] , [ ] } Enabling all options that are disabled by default Can be achieved with the ` all : true ` option iex(19)&gt; [ ...(19)&gt; &quot;a^n^&quot; , ...(19)&gt; &quot;b~2~&quot; , ...(19)&gt; &quot;[[wikilink]]&quot; ] ...(19)&gt; |&gt; as_ast ( all : true ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;a&quot; , { &quot;sup&quot; , [ ] , [ &quot;n&quot; ] , %{ } } , { &quot;br&quot; , [ ] , [ ] , %{ } } , &quot;b&quot; , { &quot;sub&quot; , [ ] , [ &quot;2&quot; ] , %{ } } , { &quot;br&quot; , [ ] , [ ] , %{ } } , { &quot;a&quot; , [ { &quot;href&quot; , &quot;wikilink&quot; } ] , [ &quot;wikilink&quot; ] , %{ wikilink : true } } ] , %{ } } ] , [ ] } Tables Are supported as long as they are preceded by an empty line. State | Abbrev | Capital -- -- : | :-- -- : | -- -- -- - Texas | TX | Austin Maine | ME | Augusta Tables may have leading and trailing vertical bars on each line | State | Abbrev | Capital | | -- -- : | :-- -- : | -- -- -- - | | Texas | TX | Austin | | Maine | ME | Augusta | Tables need not have headers, in which case all column alignments default to left. | Texas | TX | Austin | | Maine | ME | Augusta | Currently we assume there are always spaces around interior vertical unless there are exterior bars. However in order to be more GFM compatible the gfm_tables: true option can be used to interpret only interior vertical bars as a table if a separation line is given, therefore Language | Rating -- -- -- -- | -- -- -- Elixir | awesome is a table (if and only if gfm_tables: true ) while Language | Rating Elixir | awesome never is. HTML Blocks HTML is not parsed recursively or detected in all conditions right now, though GFM compliance is a goal. But for now the following holds: A HTML Block defined by a tag starting a line and the same tag starting a different line is parsed as one HTML AST node, marked with %{verbatim: true} E.g. iex(20)&gt; lines = [ &quot;&lt;div&gt;&lt;span&gt;&quot; , &quot;some&lt;/span&gt;&lt;text&gt;&quot; , &quot;&lt;/div&gt;more text&quot; ] ...(20)&gt; EarmarkParser . as_ast ( lines ) { :ok , [ { &quot;div&quot; , [ ] , [ &quot;&lt;span&gt;&quot; , &quot;some&lt;/span&gt;&lt;text&gt;&quot; ] , %{ verbatim : true } } , &quot;more text&quot; ] , [ ] } And a line starting with an opening tag and ending with the corresponding closing tag is parsed in similar fashion iex(21)&gt; EarmarkParser . as_ast ( [ &quot;&lt;span class= \\&quot; superspan \\&quot; &gt;spaniel&lt;/span&gt;&quot; ] ) { :ok , [ { &quot;span&quot; , [ { &quot;class&quot; , &quot;superspan&quot; } ] , [ &quot;spaniel&quot; ] , %{ verbatim : true } } ] , [ ] } What is HTML? We differ from strict GFM by allowing all tags not only HTML5 tags this holds for one liners.... iex(22)&gt; { :ok , ast , [ ] } = EarmarkParser . as_ast ( [ &quot;&lt;stupid /&gt;&quot; , &quot;&lt;not&gt;better&lt;/not&gt;&quot; ] ) ...(22)&gt; ast [ { &quot;stupid&quot; , [ ] , [ ] , %{ verbatim : true } } , { &quot;not&quot; , [ ] , [ &quot;better&quot; ] , %{ verbatim : true } } ] and for multi line blocks iex(23)&gt; { :ok , ast , [ ] } = EarmarkParser . as_ast ( [ &quot;&lt;hello&gt;&quot; , &quot;world&quot; , &quot;&lt;/hello&gt;&quot; ] ) ...(23)&gt; ast [ { &quot;hello&quot; , [ ] , [ &quot;world&quot; ] , %{ verbatim : true } } ] HTML Comments Are recognized if they start a line (after ws and are parsed until the next --&gt; is found all text after the next '--&gt;' is ignored E.g. iex(24)&gt; EarmarkParser . as_ast ( &quot; &lt;!-- Comment \\n comment line \\n comment --&gt; text --&gt; \\n after&quot; ) { :ok , [ { :comment , [ ] , [ &quot; Comment&quot; , &quot;comment line&quot; , &quot;comment &quot; ] , %{ comment : true } } , { &quot;p&quot; , [ ] , [ &quot;after&quot; ] , %{ } } ] , [ ] } Lists Lists are pretty much GFM compliant, but some behaviors concerning the interpreation of the markdown inside a List Item's first paragraph seem not worth to be interpreted, examples are blockquote in a tight list item which we can only have in a loose one Or a headline in a tight list item which, again is only available in the loose version in EarmarkParser. furthermore this example demonstrates how weird and definitely not useful GFM's own interpretation can get. Therefore we stick to a more predictable approach. iex(25)&gt; markdown = [ ...(25)&gt; &quot;* aa&quot; , ...(25)&gt; &quot; ```&quot; , ...(25)&gt; &quot;Second&quot; , ...(25)&gt; &quot; ```&quot; ] ...(25)&gt; as_ast ( markdown ) { :ok , [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;aa&quot; , { &quot;pre&quot; , [ ] , [ { &quot;code&quot; , [ ] , [ &quot;Second&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , %{ } } ] , [ ] } Also we do support the immediate style of block content inside lists iex(26)&gt; as_ast ( &quot;* &gt; Nota Bene!&quot; ) { :ok , [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ { &quot;blockquote&quot; , [ ] , [ { &quot;p&quot; , [ ] , [ &quot;Nota Bene!&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , %{ } } ] , [ ] } or iex(27)&gt; as_ast ( &quot;1. # Breaking...&quot; ) { :ok , [ { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ { &quot;h1&quot; , [ ] , [ &quot;Breaking...&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , [ ] } Adding Attributes with the IAL extension To block elements HTML attributes can be added to any block-level element. We use the Kramdown syntax: add the line {: attrs } following the block. iex(28)&gt; markdown = [ &quot;# Headline&quot; , &quot;{:.from-next-line}&quot; ] ...(28)&gt; as_ast ( markdown ) { :ok , [ { &quot;h1&quot; , [ { &quot;class&quot; , &quot;from-next-line&quot; } ] , [ &quot;Headline&quot; ] , %{ } } ] , [ ] } Headers can also have the IAL string at the end of the line iex(29)&gt; markdown = [ &quot;# Headline{:.from-same-line}&quot; ] ...(29)&gt; as_ast ( markdown ) { :ok , [ { &quot;h1&quot; , [ { &quot;class&quot; , &quot;from-same-line&quot; } ] , [ &quot;Headline&quot; ] , %{ } } ] , [ ] } A special use case is headers inside blockquotes which allow for some nifty styling in ex_doc * see this PR if you are interested in the technical details iex(30)&gt; markdown = [ &quot;&gt; # Headline{:.warning}&quot; ] ...(30)&gt; as_ast ( markdown ) { :ok , [ { &quot;blockquote&quot; , [ ] , [ { &quot;h1&quot; , [ { &quot;class&quot; , &quot;warning&quot; } ] , [ &quot;Headline&quot; ] , %{ } } ] , %{ } } ] , [ ] } This also works for headers inside lists iex(31)&gt; markdown = [ &quot;- # Headline{:.warning}&quot; ] ...(31)&gt; as_ast ( markdown ) { :ok , [ { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ { &quot;h1&quot; , [ { &quot;class&quot; , &quot;warning&quot; } ] , [ &quot;Headline&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , [ ] } It still works for inline code, as it did before iex(32)&gt; markdown = &quot;`Enum.map`{:lang=elixir}&quot; ...(32)&gt; as_ast ( markdown ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;code&quot; , [ { &quot;class&quot; , &quot;inline&quot; } , { &quot;lang&quot; , &quot;elixir&quot; } ] , [ &quot;Enum.map&quot; ] , %{ } } ] , %{ } } ] , [ ] } attrs can be one or more of: .className #id name=value, name=&quot;value&quot;, or name='value' For example: # Warning { : . red } Do not turn off the engine if you are at altitude . { : . boxed #warning spellcheck=&quot;true&quot;} To links or images It is possible to add IAL attributes to generated links or images in the following format. iex(33)&gt; markdown = &quot;[link](url) {: .classy}&quot; ...(33)&gt; EarmarkParser . as_ast ( markdown ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;class&quot; , &quot;classy&quot; } , { &quot;href&quot; , &quot;url&quot; } ] , [ &quot;link&quot; ] , %{ } } ] , %{ } } ] , [ ] } For both cases, malformed attributes are ignored and warnings are issued. iex(34)&gt; [ &quot;Some text&quot; , &quot;{:hello}&quot; ] |&gt; Enum . join ( &quot; \\n &quot; ) |&gt; EarmarkParser . as_ast ( ) { :error , [ { &quot;p&quot; , [ ] , [ &quot;Some text&quot; ] , %{ } } ] , [ { :warning , 2 , &quot;Illegal attributes [ \\&quot; hello \\&quot; ] ignored in IAL&quot; } ] } It is possible to escape the IAL in both forms if necessary iex(35)&gt; markdown = &quot;[link](url) \\\\ {: .classy}&quot; ...(35)&gt; EarmarkParser . as_ast ( markdown ) { :ok , [ { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;url&quot; } ] , [ &quot;link&quot; ] , %{ } } , &quot;{: .classy}&quot; ] , %{ } } ] , [ ] } This of course is not necessary in code blocks or text lines containing an IAL-like string, as in the following example iex(36)&gt; markdown = &quot;hello {:world}&quot; ...(36)&gt; EarmarkParser . as_ast ( markdown ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;hello {:world}&quot; ] , %{ } } ] , [ ] } Limitations Block-level HTML is correctly handled only if each HTML tag appears on its own line. So &lt; div &gt; &lt; div &gt; hello &lt; / div &gt; &lt; / div &gt; will work. However. the following won't &lt; div &gt; hello &lt; / div &gt; John Gruber's tests contain an ambiguity when it comes to lines that might be the start of a list inside paragraphs. One test says that This is the text * of a paragraph that I wrote is a single paragraph. The &quot;*&quot; is not significant. However, another test has * A list item * an another and expects this to be a nested list. But, in reality, the second could just be the continuation of a paragraph. I've chosen always to use the second interpretation—a line that looks like a list item will always be a list item. Rendering of block and inline elements. Block or void HTML elements that are at the absolute beginning of a line end the preceding paragraph. Thusly mypara &lt; hr / &gt; Becomes &lt; p &gt; mypara &lt; / p &gt; &lt; hr / &gt; While mypara &lt; hr / &gt; will be transformed into &lt; p &gt; mypara &lt; hr / &gt; &lt; / p &gt; Annotations N.B. this is an experimental feature from v1.4.16-pre on and might change or be removed again The idea is that each markdown line can be annotated, as such annotations change the semantics of Markdown they have to be enabled with the annotations option. If the annotations option is set to a string (only one string is supported right now, but a list might be implemented later on, hence the name), the last occurrence of that string in a line and all text following it will be added to the line as an annotation. Depending on how that line will eventually be parsed, this annotation will be added to the meta map (the 4th element in an AST quadruple) with the key :annotation In the current version the annotation will only be applied to verbatim HTML tags and paragraphs Let us show some examples now: Annotated Paragraphs iex(37)&gt; as_ast ( &quot;hello %&gt; annotated&quot; , annotations : &quot;%&gt;&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;hello &quot; ] , %{ annotation : &quot;%&gt; annotated&quot; } } ] , [ ] } If we annotate more than one line in a para the first annotation takes precedence iex(38)&gt; as_ast ( &quot;hello %&gt; annotated \\n world %&gt; discarded&quot; , annotations : &quot;%&gt;&quot; ) { :ok , [ { &quot;p&quot; , [ ] , [ &quot;hello \\n world &quot; ] , %{ annotation : &quot;%&gt; annotated&quot; } } ] , [ ] } Annotated HTML elements In one line iex(39)&gt; as_ast ( &quot;&lt;span&gt;One Line&lt;/span&gt; // a span&quot; , annotations : &quot;//&quot; ) { :ok , [ { &quot;span&quot; , [ ] , [ &quot;One Line&quot; ] , %{ annotation : &quot;// a span&quot; , verbatim : true } } ] , [ ] } or block elements iex(40)&gt; [ ...(40)&gt; &quot;&lt;div&gt; : annotation&quot; , ...(40)&gt; &quot; &lt;span&gt;text&lt;/span&gt;&quot; , ...(40)&gt; &quot;&lt;/div&gt; : discarded&quot; ...(40)&gt; ] |&gt; as_ast ( annotations : &quot; : &quot; ) { :ok , [ { &quot;div&quot; , [ ] , [ &quot; &lt;span&gt;text&lt;/span&gt;&quot; ] , %{ annotation : &quot; : annotation&quot; , verbatim : true } } ] , [ ] } Commenting your Markdown Although many markdown elements do not support annotations yet, they can be used to comment your markdown, w/o cluttering the generated AST with comments iex(41)&gt; [ ...(41)&gt; &quot;# Headline --&gt; first line&quot; , ...(41)&gt; &quot;- item1 --&gt; a list item&quot; , ...(41)&gt; &quot;- item2 --&gt; another list item&quot; , ...(41)&gt; &quot;&quot; , ...(41)&gt; &quot;&lt;http://somewhere/to/go&gt; --&gt; do not go there&quot; ...(41)&gt; ] |&gt; as_ast ( annotations : &quot;--&gt;&quot; ) { :ok , [ { &quot;h1&quot; , [ ] , [ &quot;Headline&quot; ] , %{ } } , { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;item1 &quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;item2 &quot; ] , %{ } } ] , %{ } } , { &quot;p&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;http://somewhere/to/go&quot; } ] , [ &quot;http://somewhere/to/go&quot; ] , %{ } } , &quot; &quot; ] , %{ annotation : &quot;--&gt; do not go there&quot; } } ] , [ ] }","ref":"EarmarkParser.html"},{"type":"function","title":"EarmarkParser.as_ast/2","doc":"iex(42)&gt; markdown = &quot;My `code` is **best**&quot; ...(42)&gt; { :ok , ast , [ ] } = EarmarkParser . as_ast ( markdown ) ...(42)&gt; ast [ { &quot;p&quot; , [ ] , [ &quot;My &quot; , { &quot;code&quot; , [ { &quot;class&quot; , &quot;inline&quot; } ] , [ &quot;code&quot; ] , %{ } } , &quot; is &quot; , { &quot;strong&quot; , [ ] , [ &quot;best&quot; ] , %{ } } ] , %{ } } ] iex(43)&gt; markdown = &quot;```elixir \\n IO.puts 42 \\n ```&quot; ...(43)&gt; { :ok , ast , [ ] } = EarmarkParser . as_ast ( markdown , code_class_prefix : &quot;lang-&quot; ) ...(43)&gt; ast [ { &quot;pre&quot; , [ ] , [ { &quot;code&quot; , [ { &quot;class&quot; , &quot;elixir lang-elixir&quot; } ] , [ &quot;IO.puts 42&quot; ] , %{ } } ] , %{ } } ] Rationale : The AST is exposed in the spirit of Floki's .","ref":"EarmarkParser.html#as_ast/2"},{"type":"function","title":"EarmarkParser.version/0","doc":"Accesses current hex version of the EarmarkParser application. Convenience for iex usage.","ref":"EarmarkParser.html#version/0"},{"type":"type","title":"EarmarkParser.ast/0","doc":"","ref":"EarmarkParser.html#t:ast/0"},{"type":"type","title":"EarmarkParser.ast_attribute/0","doc":"","ref":"EarmarkParser.html#t:ast_attribute/0"},{"type":"type","title":"EarmarkParser.ast_attribute_name/0","doc":"","ref":"EarmarkParser.html#t:ast_attribute_name/0"},{"type":"type","title":"EarmarkParser.ast_attribute_value/0","doc":"","ref":"EarmarkParser.html#t:ast_attribute_value/0"},{"type":"type","title":"EarmarkParser.ast_attributes/0","doc":"","ref":"EarmarkParser.html#t:ast_attributes/0"},{"type":"type","title":"EarmarkParser.ast_meta/0","doc":"","ref":"EarmarkParser.html#t:ast_meta/0"},{"type":"type","title":"EarmarkParser.ast_node/0","doc":"","ref":"EarmarkParser.html#t:ast_node/0"},{"type":"type","title":"EarmarkParser.ast_tag/0","doc":"","ref":"EarmarkParser.html#t:ast_tag/0"},{"type":"type","title":"EarmarkParser.ast_tuple/0","doc":"","ref":"EarmarkParser.html#t:ast_tuple/0"},{"type":"module","title":"EarmarkParser.Enum.Ext","doc":"Some extensions of Enum functions","ref":"EarmarkParser.Enum.Ext.html"},{"type":"function","title":"EarmarkParser.Enum.Ext.reduce_with_end/3","doc":"reduce_with_end is like Enum.reduce for lists, but the reducer function is called for each element of the list with the tuple {:element, element} and the accumulator and once more at the end with :end and the accumulator iex(1)&gt; reducer = ...(1)&gt; fn { :element , nil } , { partial , result } -&gt; { [ ] , [ Enum . sum ( partial ) | result ] } ...(1)&gt; { :element , val } , { partial , result } -&gt; { [ val | partial ] , result } ...(1)&gt; :end , { partial , result } -&gt; [ Enum . sum ( partial ) | result ] |&gt; Enum . reverse ...(1)&gt; end ...(1)&gt; [ 1 , 2 , nil , 4 , 1 , 0 , nil , 3 , 2 , 2 ] ...(1)&gt; |&gt; reduce_with_end ( { [ ] , [ ] } , reducer ) [ 3 , 5 , 7 ] N.B. that in the treatment of :end we can change the shape of the accumulator w/o any penalty concerning the complexity of the reducer function","ref":"EarmarkParser.Enum.Ext.html#reduce_with_end/3"},{"type":"function","title":"EarmarkParser.Enum.Ext.reverse_map_reduce/3","doc":"Like map_reduce but reversing the list iex(2)&gt; replace_nil_and_count = fn ele , acc -&gt; ...(2)&gt; if ele , do : { ele , acc } , else : { &quot;&quot; , acc + 1 } ...(2)&gt; end ...(2)&gt; [ &quot;y&quot; , nil , &quot;u&quot; , nil , nil , &quot;a&quot; , nil ] |&gt; reverse_map_reduce ( 0 , replace_nil_and_count ) { [ &quot;&quot; , &quot;a&quot; , &quot;&quot; , &quot;&quot; , &quot;u&quot; , &quot;&quot; , &quot;y&quot; ] , 4 }","ref":"EarmarkParser.Enum.Ext.html#reverse_map_reduce/3"},{"type":"module","title":"EarmarkParser.Options","doc":"","ref":"EarmarkParser.Options.html"},{"type":"function","title":"EarmarkParser.Options.normalize/1","doc":"Use normalize before passing it into any API function iex(1)&gt; options = normalize ( annotations : &quot;%%&quot; ) ...(1)&gt; options . annotations ~r{ \\A (.*)(%%.*)}","ref":"EarmarkParser.Options.html#normalize/1"}]